#include "Complex.h"
#include <iostream>

Complex::Complex(void)
{
  nr_instances++;
  real = 0.0;
  imag = 0.0;
}
Complex::Complex(double r)
{
  nr_instances++;
  real = r;
  imag = 0.0;
}
Complex::Complex(double r,double i)
{
  nr_instances++;
  real = r;
  imag = i;
}
Complex::Complex(const Complex &c)
{
  nr_instances++;
  real = c.real;
  imag = c.imag;
}
Complex::~Complex(void)
{

}
double Complex::get_real(void)
{
  return real;
}
double Complex::get_imag(void)
{
  return imag;
}
void Complex::display(void)
{
  std::cout << "Real: " << real << " Imag: " << imag << std::endl;
}
Complex& Complex::add(const Complex &c)
{
  real += c.real;
  imag += c.imag;
}
Complex& Complex::add(const Complex &c1,const Complex &c2)
{
  this->real = c1.real+c2.real;
  this->imag = c1.imag+c2.imag;
}
Complex& Complex::add2(Complex c1,Complex c2)
{
  this->real = c1.real;
  this->imag = c2.imag;
}
void Complex::display_nr_instances(void)
{
  std::cout << "Nr Instances: " << nr_instances << std::endl;
}
std::ostream& operator<<(std::ostream &os,const Complex &c)
{
  os << "(" << c.real << "," << c.imag << ")\n";
}
Complex operator+(const Complex &c1,const Complex &c2)
{
  Complex c3;
  c3.add(c1);
  c3.add(c2);
  return c3;
}
Complex Complex::operator=(const Complex &c)
{
  Complex c2 = c;
  return c2;
}
Complex Complex::operator+(const Complex &c)
{
  Complex c1 = c;
  c1.add(c);
  return c1;
}
