#ifndef __COMPLEX_H__
#define __COMPLEX_H__

#include <iostream>

class Complex
{
  friend std::ostream& operator<<(std::ostream &os, const Complex &c);
  friend Complex operator+(const Complex &c1,const Complex &c2);
 public:
  Complex operator+(const Complex &c);
  Complex operator=(const Complex &c);

  Complex(void);
  Complex(double r);
  Complex(double r,double i);
  Complex(const Complex &c);
  ~Complex(void);

  Complex& add(const Complex &c);
  Complex& add(const Complex &c1,const Complex &c2);
  Complex& add2(Complex c1,Complex c2);
  
  void display(void);
  void display_nr_instances(void);

  static int nr_instances;
  double get_real(void);
  double get_imag(void);



 private:
  double real;
  double imag;
 protected:

};
#endif

